MODULE CocoFrames;
(* Generated by m3bundle; see its manpage. *)

IMPORT Bundle, BundleRep, Text;
IMPORT Thread, Wr, TextWr;

TYPE T = Bundle.T OBJECT OVERRIDES get := LookUp END;

VAR bundle: T := NIL;

PROCEDURE Get(): Bundle.T =
  BEGIN
    IF (bundle = NIL) THEN bundle := NEW (T) END;
    RETURN bundle;
  END Get;

PROCEDURE LookUp (<*UNUSED*> self: T;  element: TEXT): TEXT = 
  BEGIN
    FOR i := 0 TO LAST (Names)-1 DO
      IF Text.Equal (Names[i], element) THEN
        IF Elements[i] = NIL THEN Elements[i] := GetElt (i) END;
        RETURN Elements[i];
      END;
    END;
    RETURN NIL;
  END LookUp;

CONST Names = ARRAY [0..4] OF TEXT {
  "parser.frm",
  "scanner.frm",
  "interface.frm",
  "compiler.frm",
  NIL
};

VAR Elements := ARRAY [0..4] OF TEXT {
  NIL (* E0 .. E0_0 *),
  NIL (* E1 .. E1_1 *),
  E2,
  NIL (* E3 .. E3_0 *),
  NIL
};

PROCEDURE GetElt (n: INTEGER): TEXT =
  <*FATAL Thread.Alerted, Wr.Failure *>
  VAR wr := TextWr.New ();
  BEGIN
    CASE n OF
    | 0 =>
        Wr.PutText (wr, E0);
        Wr.PutText (wr, E0_0);
    | 1 =>
        Wr.PutText (wr, E1);
        Wr.PutText (wr, E1_0);
        Wr.PutText (wr, E1_1);
    | 3 =>
        Wr.PutText (wr, E3);
        Wr.PutText (wr, E3_0);
    ELSE (*skip*)
    END;
    RETURN TextWr.ToText (wr);
  END GetElt;

CONST E0 = 
   "MODULE -->Parser EXPORTS -->Grammar ;\n\n(* Parser generated by m3coco "
 & "*)\n\nIMPORT Rd, Thread ;\n\n-->Declarations\n\nCONST \n  minErrDist = "
 & "2 ;  (* minimal distance (good tokens) between two errors *)\n\nTYPE\n "
 & " SymSetRange = [0 .. -->MaxSets] ;\n\nCONST\n  SymSet = ARRAY SymSetRan"
 & "ge OF SymbolSet {\n    -->SymbolSets\n  } ;\n\n  PragmaSet = SymbolSet "
 & "{ -->PragmaSet } ;\n\nREVEAL\n  Parser = PublicP BRANDED OBJECT\n      "
 & "       s       : Scanner ;\n             err     : ErrHandler ;\n      "
 & "       cur     : ScanSymbol ; (* current symbol *)\n             next  "
 & "  : ScanSymbol ; (* next [lookahead] symbol *)\n             errDist : "
 & "CARDINAL     (* number of tokens since last err *)\n           OVERRIDE"
 & "S\n             init   := Init ;\n             error  := SemError ;\n  "
 & "           string := GetString ;\n             name   := GetName ;\n   "
 & "          offset := GetOffset ;\n             line   := GetLine ;\n    "
 & "         column := GetColumn ;\n             length := GetLength ;\n   "
 & "          parse  := Parse\n           END ;\n\nPROCEDURE SemError(p : P"
 & "arser ; msg : TEXT) =\nBEGIN\n  IF (p.errDist >= minErrDist) THEN\n    "
 & "p.err.error(p.cur.line, p.cur.column, msg)\n  END ;\n  p.errDist := 0\n"
 & "END SemError ;\n\nPROCEDURE GetString(p : Parser) : TEXT =\nBEGIN\n  RE"
 & "TURN p.cur.string\nEND GetString ;\n\nPROCEDURE GetName(p : Parser) : T"
 & "EXT =\nBEGIN\n  RETURN p.cur.name\nEND GetName ;\n\nPROCEDURE GetOffset"
 & "(p : Parser) : CARDINAL =\nBEGIN\n  RETURN p.cur.offset\nEND GetOffset "
 & ";\n\nPROCEDURE GetLine(p : Parser) : CARDINAL =\nBEGIN\n  RETURN p.cur."
 & "line\nEND GetLine ;\n\nPROCEDURE GetColumn(p : Parser) : CARDINAL =\nBE"
 & "GIN\n  RETURN p.cur.column\nEND GetColumn ;\n\nPROCEDURE GetLength(p : "
 & "Parser) : CARDINAL =\nBEGIN\n  RETURN p.cur.length\nEND GetLength ;\n\n"
 & "PROCEDURE SynError(p : Parser ; msg : TEXT) =\nBEGIN\n  IF (p.errDist >"
 & "= minErrDist) THEN\n    p.err.error(p.next.line, p.next.column, msg)\n "
 & " END ;\n  p.errDist := 0\nEND SynError ;\n\nPROCEDURE Get(p : Parser) ="
 & "\nBEGIN\n  p.cur := p.next ;\n  REPEAT\n    p.s.get(p.next) ;\n    IF ("
 & "p.next.sym IN PragmaSet) THEN\n  ";

CONST E0_0 = 
   "    VAR tmp := p.cur ;\n      BEGIN\n        p.cur := p.next ;\n       "
 & " -->Pragmas\n        p.cur := tmp\n      END\n    END\n  UNTIL (NOT (p."
 & "next.sym IN PragmaSet)) ;\n  INC(p.errDist)\nEND Get ;\n\nPROCEDURE Exp"
 & "ect(p : Parser ; sym : Symbol) =\nBEGIN\n  IF (p.next.sym = sym) THEN\n"
 & "    Get(p)\n  ELSE\n    SynError(p, \"expected \'\" & SymbolName[sym] &"
 & "\n                  \"\', got \'\" & SymbolName[p.next.sym] & \"\'\")\n"
 & "  END\nEND Expect ;\n\n<*NOWARN*>PROCEDURE ExpectWeak(p : Parser ; sym "
 & ": Symbol ; follow : SymSetRange) =\nBEGIN\n  IF (p.next.sym = sym) THEN"
 & "\n    Get(p)\n  ELSE\n    SynError(p, \"expected \'\" & SymbolName[sym]"
 & " &\n                  \"\', got \'\" & SymbolName[p.next.sym] & \"\'\")"
 & " ;\n    WHILE (NOT (p.next.sym IN SymSet[follow])) DO\n      Get(p)\n  "
 & "  END\n  END\nEND ExpectWeak ;\n\n<*NOWARN*>PROCEDURE WeakSeparator(p :"
 & " Parser ; sym : Symbol ;\n                        syFol, repFol : SymSe"
 & "tRange) : BOOLEAN =\nVAR\n  s : SymbolSet ;\nBEGIN\n  IF (p.next.sym = "
 & "sym) THEN\n    Get(p) ;\n    RETURN TRUE\n  ELSIF (p.next.sym IN SymSet"
 & "[repFol]) THEN\n    RETURN FALSE\n  ELSE\n    s := SymSet[0] + SymSet[s"
 & "yFol] + SymSet[repFol] ;\n    SynError(p, \"expected \'\" & SymbolName["
 & "sym] &\n                  \"\', got \'\" & SymbolName[p.next.sym] & \"\'"
 & "\") ;\n    WHILE (NOT (p.next.sym IN s)) DO\n      Get(p)\n    END ;\n "
 & "   RETURN (p.next.sym IN SymSet[syFol])\n  END\nEND WeakSeparator ;\n\n"
 & "-->Productions\n\nPROCEDURE Parse(p : Parser) RAISES { Rd.Failure, Thre"
 & "ad.Alerted } =\nBEGIN\n  -->ParseRoot\nEND Parse ;\n\nPROCEDURE Init(p "
 & ": Parser ; s : Scanner ; e : ErrHandler) : Parser =\nBEGIN\n  p.s      "
 & " := s ;\n  p.err     := e ;\n  p.errDist := minErrDist ;\n  RETURN p\nE"
 & "ND Init ;\n\nBEGIN\nEND -->Parser.\n";

CONST E1 = 
   "MODULE -->Scanner EXPORTS -->Grammar ;\n\n(* Scanner generated by m3coc"
 & "o *)\n\nIMPORT ASCII, Text, Rd, Thread ;\n\nCONST\n  StartState = ARRAY"
 & " CHAR OF CARDINAL {\n    -->StartTable\n  } ;\n\n  IgnoreCase = -->Igno"
 & "reCase ;\n\nREVEAL\n  Scanner = PublicS BRANDED OBJECT\n              e"
 & "rr         : ErrHandler ;\n              lastCh      : CHAR ;          "
 & "    (* last input char *)\n              ch          : CHAR ;          "
 & "    (* current input char *)\n              offset      : CARDINAL ;   "
 & "       (* offset into stream *)\n              currentLine : CARDINAL ;"
 & "          (* current input line *)\n              currentCol  : CARDINA"
 & "L ;          (* current input column *)\n              lastLineLen : CA"
 & "RDINAL ;          (* length of previous line *)\n              apx     "
 & "    : CARDINAL ;          (* length of appendix *)\n                   "
 & "                             (* (for CONTEXT) *)\n              oldEols"
 & "     : CARDINAL ;          (* number of EOLs in comment *)\n           "
 & "   rd          : Rd.T ;              (* the input stream *)\n          "
 & "    buf         : REF ARRAY OF CHAR ; (* the input buffer *)\n         "
 & "     bufLen      : CARDINAL            (* length of the input buffer *)"
 & "\n            OVERRIDES\n              init       := Init ;\n          "
 & "    get        := Get\n            END ;\n\nPROCEDURE NextCh(s : Scanne"
 & "r ; record := FALSE) RAISES { Rd.Failure,\n                            "
 & "                             Rd.EndOfFile,\n                           "
 & "                              Thread.Alerted } =\n(* Updates global var"
 & "iable s.ch *)\nVAR newBuf : REF ARRAY OF CHAR ;\nBEGIN\n  s.lastCh := s"
 & ".ch ;\n  s.ch := Rd.GetChar(s.rd) ;\n  INC(s.offset) ;\n  IF (s.ch = \'"
 & "\\n\') THEN\n    INC(s.currentLine) ;\n    s.lastLineLen := s.currentCo"
 & "l ;\n    s.currentCol := 0\n  ELSE\n    INC(s.currentCol)\n  END ;\n  I"
 & "F (record) THEN\n    IF (s.bufLen = LAST(s.buf^)) THEN\n    (* double t"
 & "he buffer size *)\n      newBuf := NEW(REF ARRAY OF CHAR, NUMBER(s.buf^"
 & ") * 2) ;\n      SUBARRAY(newBuf^, 0, NUMBER(s.buf^)) := s.buf^ ;\n   ";

CONST E1_0 = 
   "   s.buf := newBuf\n    END ;\n    INC(s.bufLen) ;\n    s.buf[s.bufLen]"
 & " := s.ch\n  END ;\n  IF (IgnoreCase) THEN\n    s.ch := ASCII.Upper[s.ch"
 & "]\n  END\nEND NextCh ;\n\nPROCEDURE PrevCh(s : Scanner) =\nBEGIN\n  Rd."
 & "UnGetChar(s.rd) ;\n  s.ch := s.lastCh ;\n  DEC(s.offset) ;\n  IF (s.buf"
 & "Len > 0) THEN\n    DEC(s.bufLen)\n  END ;\n  IF (s.currentCol = 0) THEN"
 & "\n    s.currentCol := s.lastLineLen ;\n    DEC(s.currentLine)\n  ELSE\n"
 & "    DEC(s.currentCol)\n  END\nEND PrevCh ;\n\nPROCEDURE Comment(s : Sca"
 & "nner) : BOOLEAN RAISES { Rd.Failure,\n                                 "
 & "                 Rd.EndOfFile,\n                                       "
 & "           Thread.Alerted } =\nVAR\n  level                : CARDINAL :"
 & "= 1 ;\n  <*NOWARN*> startLine : CARDINAL := s.currentLine ;\nBEGIN\n  -"
 & "->Comment\n  RETURN FALSE\nEND Comment ;\n\nPROCEDURE GetSym(s : Scanne"
 & "r) : Symbol RAISES { Rd.Failure,\n                                     "
 & "           Rd.EndOfFile,\n                                             "
 & "   Thread.Alerted } =\nVAR\n  state  : CARDINAL ;\n\n  PROCEDURE Equal("
 & "text : TEXT) : BOOLEAN =\n  VAR tmp : ARRAY [0 .. -->MaxLiteralWidth] O"
 & "F CHAR ;\n      i   : CARDINAL ;\n  BEGIN\n    Text.SetChars(tmp, text)"
 & " ;\n    i := 0 ;\n    WHILE ((i < s.bufLen) AND (s.buf[i] = tmp[i])) DO"
 & "\n      INC(i)\n    END ;\n    RETURN (i = s.bufLen)\n  END Equal ;\n\n"
 & "  -->CheckLiteral\n\nBEGIN\n  s.buf[0]  := s.ch ;\n  s.bufLen  := 0 ;\n"
 & "  s.apx     := 0 ;\n  state     := StartState[s.ch] ;\n  LOOP\n    Next"
 & "Ch(s, TRUE) ;\n    CASE state OF\n    -->GetCore\n    ELSE\n      RETUR"
 & "N -->UnknownSym (* NextCh already done *)\n    END\n  END\nEND GetSym ;"
 & "\n\nPROCEDURE Get(s : Scanner ; VAR ss : ScanSymbol) RAISES { Rd.Failur"
 & "e,\n                                                          Thread.Al"
 & "erted } =\nBEGIN\n  TRY\n    -->GetPrelude\n    ss.offset := s.offset -"
 & " 1 ;\n    ss.line   := s.currentLine ;\n    ss.column := s.currentCol ;"
 & "\n    ss.sym    := GetSym(s) ;\n    ss.length := s.bufLen ;\n    ss.str"
 & "ing := Text.FromChars(SUBARRAY(s.buf^, 0, s.bufLen)) ;\n    IF (IgnoreC"
 & "ase) THEN\n      VAR tmp ";

CONST E1_1 = 
   ":= NEW(REF ARRAY OF CHAR, s.bufLen) ;\n      BEGIN\n        FOR i := 0 "
 & "TO s.bufLen - 1 DO\n          tmp[i] := ASCII.Upper[s.buf[i]]\n        "
 & "END ;\n        ss.name := Text.FromChars(tmp^)\n      END\n    ELSE\n  "
 & "    ss.name := ss.string\n    END\n  EXCEPT\n    Rd.EndOfFile =>\n     "
 & " ss.line := s.currentLine ;\n      ss.column := s.currentCol ;\n      s"
 & "s.sym    := -->EofSym ;\n      ss.string := NIL ;\n      ss.name   := N"
 & "IL\n  END\nEND Get ;\n\nPROCEDURE Init(s : Scanner ; rd : Rd.T ; e : Er"
 & "rHandler) : Scanner =\nBEGIN\n  s.rd          := rd ;\n  s.err         "
 & ":= e ;\n  s.offset      := 0 ;\n  s.currentLine := 1 ;\n  s.currentCol "
 & " := 0 ;\n  s.lastLineLen := 0 ;\n  s.oldEols     := 0 ;\n  s.apx       "
 & "  := 0 ;\n  s.lastCh      := ASCII.NUL ;\n  s.buf         := NEW(REF AR"
 & "RAY OF CHAR, 128) ;\n  s.bufLen      := 0 ;\n  TRY\n    NextCh(s)\n  EX"
 & "CEPT ELSE END ;\n  RETURN s\nEND Init ;\n\nBEGIN\nEND -->Scanner.\n";

CONST E2 = 
   "INTERFACE -->Grammar ;\n\n(* auto-generated m3coco interface *)\n\nIMPO"
 & "RT Rd, Thread ;\n\nTYPE\n  Symbol = {\n    -->Symbols\n  } ;\n\n  Symbo"
 & "lSet = SET OF Symbol ;\n\n  Scanner <: PublicS ;\n  Parser  <: PublicP "
 & ";\n\n  ScanSymbol = RECORD\n                 sym    : Symbol ;   (* sym"
 & "bol *)\n                 offset : CARDINAL ; (* offset in characters in"
 & "to stream *)\n                 line   : CARDINAL ; (* line number of st"
 & "arting character *)\n                 column : CARDINAL ; (* column num"
 & "ber of starting character *)\n                 length : CARDINAL ; (* l"
 & "ength of symbol string *)\n                 string : TEXT ;     (* verb"
 & "atim text for symbol *)\n                 name   : TEXT       (* case-s"
 & "pecific text for symbol *)\n               END ;\n\n  PublicS = OBJECT\n"
 & "            METHODS\n              init(rd : Rd.T ; e : ErrHandler) : S"
 & "canner ;\n              get(VAR s : ScanSymbol) RAISES { Rd.Failure, Th"
 & "read.Alerted } ;\n            END ;\n\n  PublicP = OBJECT\n            "
 & "METHODS\n              init(s : Scanner ; e : ErrHandler) : Parser ;\n "
 & "             error(msg : TEXT) ;\n              string() : TEXT ;\n    "
 & "          name()   : TEXT ;\n              offset() : CARDINAL ;\n     "
 & "         line()   : CARDINAL ;\n              column() : CARDINAL ;\n  "
 & "            length() : CARDINAL ;\n              parse() RAISES { Rd.Fa"
 & "ilure, Thread.Alerted } ;\n            END ;\n\n  ErrHandler = OBJECT\n"
 & "               METHODS\n                 error(line, col : CARDINAL ; m"
 & "sg : TEXT)\n               END ;\n\nCONST\n  SymbolName = ARRAY Symbol "
 & "OF TEXT {\n    -->SymbolNames\n  } ;\n\nEND -->Grammar.\n";

CONST E3 = 
   "MODULE -->Grammar EXPORTS Main ;\n\n(* This is an example of a rudiment"
 & "ary main module for use with m3coco *)\n\nIMPORT -->Grammar ;\n\nIMPORT"
 & " Text, Rd, Wr, Fmt, Params, Stdio, FileRd, Process, Thread, Pathname ;\n"
 & "\n<* FATAL Rd.Failure, Wr.Failure, Thread.Alerted *>\n\n(* ------------"
 & "--------------- error handler ------------------------------- *)\n\nTYP"
 & "E\n  Err = -->Grammar.ErrHandler BRANDED OBJECT\n          num : CARDIN"
 & "AL := 0\n        OVERRIDES\n          error := GenError\n        END ;\n"
 & "       \nPROCEDURE GenError(e : Err ; line : CARDINAL ; col : CARDINAL "
 & "; msg : TEXT) =\nBEGIN\n  INC(e.num) ;\n  TRY\n    Wr.PutText(Stdio.std"
 & "err, Fmt.F(\"line %3s col %2s: %s\\n\", Fmt.Int(line),\n               "
 & "                                              Fmt.Int(col), msg))\n  EX"
 & "CEPT ELSE END\nEND GenError ;\n\nVAR rd         : Rd.T ;\n    e        "
 & "  : Err ;\n    s          : -->Grammar.Scanner ;\n    p          : -->G"
 & "rammar.Parser ;\n    scanOnly   : BOOLEAN ;\n    sourceFile : TEXT ;\n "
 & "   ss         : -->Grammar.ScanSymbol ;\n\nBEGIN\n\n(* check on correct"
 & " parameter usage *)\n\n  IF ((Params.Count = 3) AND Text.Equal(Params.G"
 & "et(1), \"-scan\")) THEN\n    scanOnly   := TRUE ;\n    sourceFile := Pa"
 & "rams.Get(2)\n  ELSIF (Params.Count = 2) THEN\n    scanOnly   := FALSE ;"
 & "\n    sourceFile := Params.Get(1)\n  ELSE\n    Wr.PutText(Stdio.stderr,"
 & " \"Usage: \" & Pathname.Base(Params.Get(0))\n                          "
 & "             & \" [-scan] source-file\\n\") ;\n    Process.Exit(1)\n  E"
 & "ND ;\n\n  TRY\n    rd := FileRd.Open(sourceFile)\n  EXCEPT\n  ELSE\n   "
 & " Wr.PutText(Stdio.stderr, \"cannot open \'\" & sourceFile & \"\'\\n\") "
 & ";\n    Process.Exit(1)\n  END ;\n\n  e := NEW(Err) ;\n  s := NEW(-->Gra"
 & "mmar.Scanner).init(rd, e) ;\n\n  IF (scanOnly) THEN\n    Wr.PutText(Std"
 & "io.stdout, \"Scanning...\\n\") ;\n    Wr.Flush(Stdio.stdout) ;\n\n    s"
 & ".get(ss) ;\n    WHILE (ss.sym # -->Grammar.-->EofSym) DO\n      Wr.PutT"
 & "ext(Stdio.stdout, Fmt.F(\"line %3s col %2s = %s (%s)\\n\",\n           "
 & "                          Fmt.Int(ss.line), Fmt.Int(ss.column),\n      "
 & "                               --";

CONST E3_0 = 
   ">Grammar.SymbolName[ss.sym],\n                                     ss.s"
 & "tring)) ;\n      s.get(ss)\n    END\n  ELSE\n    p := NEW(-->Grammar.Pa"
 & "rser).init(s, e) ;\n\n    Wr.PutText(Stdio.stdout, \"Parsing...\\n\") ;"
 & "\n    Wr.Flush(Stdio.stdout) ;\n\n    p.parse() ;\n\n    IF (e.num > 0)"
 & " THEN\n      Wr.PutText(Stdio.stderr, \"Failed to Parse\\n\") ;\n      "
 & "Process.Exit(1)\n    END ;\n\n    Wr.PutText(Stdio.stdout, \"Parsed Cor"
 & "rectly\\n\")\n  END ;\n\n  Rd.Close(rd)\nEND -->Grammar.\n";


BEGIN
END CocoFrames.
